/*=============================================================================
	UnExtActorSample.cpp:
	Sample code to demonstrate the side of using an UnExt interface.
	
	Revision history:
		* Created by Sebastian Kaufel
=============================================================================*/

#include "UnExtSampleModPrivate.h" // This file is intentionally missing.

/*-----------------------------------------------------------------------------
	Autogenerated Guid declaration.

	Notes:
		* Typically you would want to place this inside your UnExtSampleModPrivate.h
		  header.
		* You need to define UNEXT_INCLUDE_AUDIOSUBSYSTEMS to include the UnExt
		  interfaces. This has the advantage that you just need dependecies 
		  for URenderDevices and not additional for URenderDevices, etc.
-----------------------------------------------------------------------------*/

#define UNEXT_INCLUDE_AUDIOSUBSYSTEMS
#include "UnExt.h"

/*-----------------------------------------------------------------------------
	UnExtActorSample.
-----------------------------------------------------------------------------*/

void UnExtActorSample::execStopAllSound( FFrame& Stack, RESULT_DECL )
{
	guard(UnExtActorSample::execStopAllSound);
	P_FINISH;

	UAudioSubsystem* Audio = GetLevel()->Engine->Audio;
	if ( Audio )
	{
		IHumanHeadAudioSubsystem* HumanHeadAudio = NULL;
		if ( Audio->QueryInterface(IID_IHumanHeadAudioSubsystem,(void**)&HumanHeadAudio) && HumanHeadAudio )
			HumanHeadAudio->StopAllSound();
		else
			GWarn->Logf( TEXT("StopAllSound() failed because %s does not support IHumanHeadAudioSubsystem."), Audio->GetName() );
	}

	unguardexec;
}

/*-----------------------------------------------------------------------------
	Autogenerated Guid implementation.

	Notes:
		* Autogenerated FGuids follow a similar approach as autogenerated FNames do.
		* They do not require a runtime call to be ready to use.
		* They neither require a dynamic link library (which would pull in runtime
		  depencencies) nor a static link library by using this approach.
		* This needs to be done once per package.
-----------------------------------------------------------------------------*/

#define UNEXT_GUID_ONLY
#define UNEXT_AUTOGENERATE_GUID(name,a,b,c,d) FGuid name = FGuid(a,b,c,d);
#include "UnExt.h"
#undef AUTOGENERATE_FUNCTION
#undef UNEXT_GUID_ONLY

/*----------------------------------------------------------------------------
	The End.
----------------------------------------------------------------------------*/
