/*=============================================================================
	UnExtRenDevSample.cpp:
	Sample code to demonstrate the supplier side of an interface.
	
	Revision history:
		* Created by Sebastian Kaufel
=============================================================================*/

#include "UnExtSampleDrvPrivate.h" // This file is intentionally missing.

/*-----------------------------------------------------------------------------
	Autogenerated Guid declaration.

	Notes:
		* Typically you would want to place this inside your UnExtRenDevSamplePrivate.h
		  header.
		* You need to define UNEXT_INCLUDE_RENDERDEVICES to include the UnExt
		  interfaces. This has the advantage that you just need dependecies 
		  for URenderDevices and not additional for USoundSubsystems, etc.
-----------------------------------------------------------------------------*/

#define UNEXT_INCLUDE_RENDERDEVICES
#include "UnExt.h"

/*-----------------------------------------------------------------------------
	UnExtRenDevSample class.
-----------------------------------------------------------------------------*/

class UnExtRenDevSample : public URenderDevice, public IKnowWonderRenderDevice
{
	DECLARE_CLASS(UnExtRenDevSample,URenderDevice,CLASS_Config,UnExt)

	// FUnknown Interface.
	DWORD STDCALL QueryInterface( const FGuid& RefIID, void** InterfacePtr )
	{
		if ( 0 )
		{
		}
#if ENGINE_VERSION!=433 // No point in including it for Disney's Brother Bear.
		else if ( RefIID==IID_IKnowWonderRenderDevice )
		{
			*(IKnowWonderRenderDevice**)InterfacePtr = this;
			return 1;
		}
#endif
		return 0;
	}

	// [..]
};

/*-----------------------------------------------------------------------------
	Autogenerated Guid implementation.

	Notes:
		* Autogenerated FGuids follow a similar approach as autogenerated FNames do.
		* They do not require a runtime call to be ready to use.
		* They neither require a dynamic link library (which would pull in runtime
		  depencencies) nor a static link library by using this approach.
		* This needs to be done once per package.
-----------------------------------------------------------------------------*/

#define UNEXT_GUID_ONLY
#define UNEXT_AUTOGENERATE_GUID(name,a,b,c,d) FGuid name = FGuid(a,b,c,d);
#include "UnExt.h"
#undef AUTOGENERATE_FUNCTION
#undef UNEXT_GUID_ONLY

/*----------------------------------------------------------------------------
	The End.
----------------------------------------------------------------------------*/
